<?xml version="1.0" encoding="UTF-8"?>
<!-- 
    DTR1 - Instance Identifier
    Status: draft
--><rule xmlns="http://purl.oclc.org/dsdl/schematron" abstract="true" id="II">
    <extends rule="ANY"/>
    
    <assert role="error" test="@nullFlavor or (not(@nullFlavor) and @root)">dtr1-1-II: @root is required if not null</assert>
    <assert role="error" test="not(@nullFlavor) or (@nullFlavor and not(@root))">dtr1-2-II: no @root if null</assert>
    <!--assert role="error" test="not(@nullFlavor) or (@nullFlavor and not(@extension))">dtr1-3-II: no @extension if null</assert-->
    
    <assert role="error" test="not(@nullFlavor) or (@nullFlavor and not(@identifierName))">dtr1-4-II: no @identifierName if null</assert>
    <assert role="error" test="not(@nullFlavor) or (@nullFlavor and not(@displayable))">dtr1-5-II: no @displayable if null</assert>
    <assert role="error" test="not(@nullFlavor) or (@nullFlavor and not(@reliability))">dtr1-6-II: no @reliability if null</assert>
    
    <assert role="error"
           test="not(@nullFlavor) or (@nullFlavor and not(@assigningAuthorityName))">dtr1-7-II: no @assigningAuthorityName if null</assert>
    
    <assert role="error"
           test="not(@root) or matches(string(@root), '^[0-2](\.(0|[1-9][0-9]*))*$') or matches(string(@root), '^[0-9a-zA-Z]{8}-[0-9a-zA-Z]{4}-[0-9a-zA-Z]{4}-[0-9a-zA-Z]{4}-[0-9a-zA-Z]{12}$')">dtr1-10-II: @root attribute MUST be a syntactically correct OID or UUID.</assert>
    
    <!-- 
        Issue
        DICOM has a max of 64 chars in an OID
        Canada uses 200 chars for OIDs
    -->
    <report role="warning" test="not(string-length(@root) &lt;= 128)">dtr1-8-II: @root is more than 128 characters. Please write a note to the authors of this rule if this is found to be not
        sufficient</report>
    
    <report role="warning" test="not(string-length(@extension) &lt;= 64)">dtr1-9-II: @extension is more than 64 characters. Please write a note to the authors of this rule if this is found to be not
        sufficient</report>
    
</rule>